library ieee;
use ieee.Std_logic_1164.all;
use sources.pack_Memory.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

package detecter_defaut_cache is
	procedure detecter_defaut_cache_LFU ( 
	 signal mc : inout t_cache ;
	 signal address  : in std_logic_vector(10 downto 0) ;
	 variable defaut : out boolean);
		
		
	procedure detecter_defaut_cache_LRU ( 
	signal mc : inout t_cache;
	signal address  : in std_logic_vector(10 downto 0);
	variable defaut : out boolean);	
end;



package body detecter_defaut_cache is

	procedure detecter_defaut_cache_LFU ( 
	 signal mc : inout t_cache ;
	 signal address  : in std_logic_vector(10 downto 0) ;
	 variable defaut : out boolean) is
		variable index : integer ;
		variable ensemble_courant : t_ensemble ;
	begin

		-- par defaut il y a un defaut de cache
		defaut := true;
		index := conv_integer( address(4 downto 2) );

		ensemble_courant := mc(index);
	
		-- on parcours l'ensemble
		for i in 0 to 15 loop
			if (ensemble_courant(i).bit_validite = '1') then
				if ( ensemble_courant(i).etiquette = address(10 downto 5) ) then
				-- MAJ du tag concern
				mc(index)(i).tag <= mc(index)(i).tag + 1;
				
				defaut := false;
				end if;
			end if;
		end loop;
	
	end detecter_defaut_cache_LFU;
	
	
	procedure detecter_defaut_cache_LRU ( 
	signal mc : inout t_cache;
	signal address  : in std_logic_vector(10 downto 0);
	variable defaut : out boolean) is
		variable index : integer ;
		variable ensemble_courant : t_ensemble ;

	begin
		-- par defaut il y a un defaut de cache
		defaut := true;
		index := conv_integer( address( 4 downto 2 ) );
		ensemble_courant := mc(index);
	
		-- on parcours l'ensemble
		for i in 0 to 15 loop
			if (ensemble_courant(i).bit_validite = '1') then
				if ( ensemble_courant(i).etiquette = address(10 downto 5) ) then
				-- MAJ du tag concern
				mc(index)(i).tag <= 0;
				-- MAJ des autres tags
				wait for 0 ns;
				for i in 0 to 15 loop
					if ( ensemble_courant(i).bit_validite = '1' ) then
						mc(index)(i).tag <= mc(index)(i).tag + 1;
					end if;
				end loop;
				defaut := false;
				end if;
			end if;
		end loop;
	
	end detecter_defaut_cache_LRU;
end detecter_defaut_cache;








