library ieee;
use ieee.std_logic_1164.all;

package pack_Memory is

subtype t_mot is std_logic_vector(7 downto 0);
subtype t_address is std_logic_vector(10 downto 0);

CONSTANT Latence : integer := 3;

type t_bloc is array (0 to 3) of t_mot;

type t_ligne is 
record
	bit_validite 	: std_logic;
	etiquette	: std_logic_vector(5 downto 0);
	bloc		: t_bloc;
	tag		: integer;
	maj		: std_logic;
end record;

type t_ensemble is array (0 to 15) of t_ligne;

type t_cache is array (0 to 7) of t_ensemble;

type t_etat is ( DECODE , SEARCH , LOAD , EXEC );
type t_state is ( LECTURE1 , LECTURE2 , LECTURE3 , LECTURE4 , RECHERCHE , ECRITURE1 , ECRITURE2 , ECRITURE3 , ECRITURE4 , FINAL);

end pack_Memory;







