----------------------------------------------------------------
-- Test Bench pour le composant memory_with_cache             --
-- auteur : Tib                                               --
-- date   : 14/05/2010                                        --
----------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use sources.pack_memory.all;

entity tb_memory_with_cache is
end tb_memory_with_cache;

architecture tb_memory_with_cache_arch of tb_memory_with_cache is

component Memory_with_cache is
	port(
	-- entrees
		data_in  : in t_mot;  
		address  : in t_address;
		cs	 : in std_logic;
		rw	 : in std_logic;
		reset	 : in std_logic;

	-- nouvelles entres
		clock 	 : in std_logic;
	-- sorties
		data_out : out t_mot;
		ready 	 : out std_logic;
	-- sorties qui permet d'afficher les mmoires
		sasa	 : out t_cache);
end component;

signal tb_clock, tb_reset, tb_rw, tb_cs ,tb_ready : std_logic;
signal tb_data_in, tb_data_out : std_logic_vector(1 to 8);
signal tb_address : std_logic_vector(10 downto 0);
signal res : t_cache;


begin

-- une instance du composant mmoire de 2Kio avec temps de latence de 20 cycles
u_memory : memory_with_cache
 port map (
	clock => tb_clock, reset => tb_reset, data_in => tb_data_in, data_out => tb_data_out, 
		address => tb_address, rw => tb_rw, cs => tb_cs , ready => tb_ready , sasa => res);

-- gnration d'un signal d'horloge de priode 20 ns
process
begin
	tb_clock <= '0';
	wait for 10 ns;
	tb_clock <= '1';
	wait for 10 ns;
end process;

-- test du composant memory_with_cache
process
begin
	-- initialisation
	tb_reset <= '0';
	tb_cs <= '1';
	tb_address <= (others => 'X');
	tb_data_in <= (others => 'X');
	tb_rw <= 'X';
	wait for 20 ns;
	tb_reset <= '1';
	
	wait for 11 ns;
	-- 1er top aprs initialisation
	-- test 1 : criture en rafale de la mmoire
	for i in 0 to 25 loop
		tb_cs <= '0';
		tb_rw <= '0';
		tb_address <= conv_std_logic_vector(i,11);
		tb_data_in <= conv_std_logic_vector(i,8); -- on crit les 8 bits de pds faible de l'@
		wait for 20 ns;
		tb_cs <= '1';
		wait for 800 ns;
		
			
	end loop;
	
	-- test 2 : lecture en rafale de la mmoire
	-- rsultat  lire dans tb_data_out
	for i in 0 to 25 loop
		tb_cs <= '0';
		tb_rw <= '1';
		tb_address <= conv_std_logic_vector(i,11);
		wait for 20 ns;
		tb_cs <= '1';
		wait for 20 ns;
		while(tb_ready='1')loop
			wait for 20 ns;
		end loop;
	end loop;
	
	tb_cs <= '1';
	

end process;

end tb_memory_with_cache_arch;




